function defaultsPrefInit() {
  setRefreshDefault();
}

function setRefreshDefault() {
  var strings = document.getElementById("prefsStrings");
  var defaultRefreshInterval = speeddial_gPrefBranch.getIntPref('defaultRefreshInterval');
  var currentUnitIndex = SpeedDialUtils.getTimeUnitIndex(defaultRefreshInterval);
  var currentDefaultRefresh = document.getElementById("currentDefaultRefresh");
  
  if (defaultRefreshInterval > 0) {
    defaultRefreshInterval /= SpeedDialUtils.timeUnits[currentUnitIndex];
    currentDefaultRefresh.setAttribute("value", "" + defaultRefreshInterval + " " + strings.getString(SpeedDialUtils.timeUnitNames[currentUnitIndex]));
  } else {
    currentDefaultRefresh.setAttribute("value", strings.getString('never'));
  }
}

function showDefaultRefreshDialog() {
  if (document.documentElement.openSubDialog) {
    document.documentElement.openSubDialog("chrome://speeddial/content/settings/defaultRefresh.xul", "resizable", null);
  } else {
    openDialog("chrome://speeddial/content/settings/defaultRefresh.xul", "",
               "centerscreen,chrome,dialog,resizable,dependent");
  }
}

function applyRefreshSelectDialog() {
  if (document.documentElement.openSubDialog) {
    document.documentElement.openSubDialog("chrome://speeddial/content/settings/targetSelector.xul", "resizable", [0, "defaultRefresh"]);
  } else {
    openDialog("chrome://speeddial/content/settings/targetSelector.xul", "",
               "centerscreen,chrome,dialog,resizable,dependent", [0, "defaultRefresh"]);
  }
}

function applyJavascriptSelectDialog() {
  if (document.documentElement.openSubDialog) {
    document.documentElement.openSubDialog("chrome://speeddial/content/settings/targetSelector.xul", "resizable", [0, "defaultJs"]);
  } else {
    openDialog("chrome://speeddial/content/settings/targetSelector.xul", "",
               "centerscreen,chrome,dialog,resizable,dependent", [0, "defaultJs"]);
  }
}

function applyRowsColumnsSelectDialog() {
  if (document.documentElement.openSubDialog) {
    document.documentElement.openSubDialog("chrome://speeddial/content/settings/targetSelector.xul", "resizable", [1, "defaultRowsColumns"]);
  } else {
    openDialog("chrome://speeddial/content/settings/targetSelector.xul", "",
               "centerscreen,chrome,dialog,resizable,dependent", [1, "defaultRowsColumns"]);
  }
}

function processTargetSelectorOutput(type, targetArray) {
  if (type == "defaultRefresh") {
    var defaultRefreshInterval = speeddial_gPrefBranch.getIntPref('defaultRefreshInterval');
    for (var c=0; c<targetArray.length; c++) {
      if (defaultRefreshInterval > 0) {
        speeddial_gPrefBranch.setIntPref("thumbnail-" + targetArray[c] + "-refreshinterval", defaultRefreshInterval);
      } else {
        if (speeddial_gPrefBranch.prefHasUserValue("thumbnail-" + targetArray[c] + "-refreshinterval")) {
          speeddial_gPrefBranch.clearUserPref("thumbnail-" + targetArray[c] + "-refreshinterval");
        }
      }
    }
  } else if (type == "defaultJs") {
    var defaultJs = document.getElementById("defaultDialJavascript").checked;
    for (var c=0; c<targetArray.length; c++) {
      speeddial_gPrefBranch.setBoolPref("thumbnail-" + targetArray[c] + "-js", defaultJs);
    }
  } else if (type == "defaultRowsColumns") {
    var defaultRows = parseInt(document.getElementById("rows").value);
    var defaultCols = parseInt(document.getElementById("columns").value);
    for (var c=0; c<targetArray.length; c++) {
//      speeddial_gPrefBranch.setIntPref("group-" + targetArray[c] + "-rows", defaultRows);
//      speeddial_gPrefBranch.setIntPref("group-" + targetArray[c] + "-columns", defaultCols);
      SpeedDialUtils.setNewGroupSize(targetArray[c], defaultRows, defaultCols);
    }
  }
}

